
/*
 * $Id$
 *
 * (C) by abook developers
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_CONFIG_H
#	include "../config.h"
#endif
#include "../abook.h"
#include "../db_access.h"
#include "../misc.h"
#include "../xmalloc.h"

#include "filter_interface.h"
#include "filter.h"

#include "csv_common.h"


static int allcsv_conv_table[] = {
	NAME,
	EMAIL,
	ADDRESS,
	ADDRESS2,
	CITY,
	STATE,
	ZIP,
	COUNTRY,
	PHONE,
	WORKPHONE,
	FAX,
	MOBILEPHONE,
	NICK,
	URL,
	NOTES,
	ANNIVERSARY
};

static int
allcsv_parse_file(FILE *in)
{
	init_csv_common(&ops);

	return csv_parse_file_common(in, allcsv_conv_table,
		CSV_TABLE_SIZE(allcsv_conv_table));
}

static int
allcsv_export_database(FILE *out, struct db_enumerator e)
{
	/*
	 * TODO: Should get these atomatically from abook_fileds
	 *  - JH
	 */
	int allcsv_export_fields[] = {
		NAME,
		EMAIL,
		ADDRESS,
		ADDRESS2,
		CITY,
		STATE,
		ZIP,
		COUNTRY,
		PHONE,
		WORKPHONE,
		FAX,
		MOBILEPHONE,
		NICK,
		URL,
		NOTES,
		ANNIVERSARY,
		CSV_LAST
	};

	fprintf(out, "#");
	fprintf(out, "\"NAME\",");
	fprintf(out, "\"EMAIL\",");
	fprintf(out, "\"ADDRESS\",");
	fprintf(out, "\"ADDRESS2\",");
	fprintf(out, "\"CITY\",");
	fprintf(out, "\"STATE\",");
	fprintf(out, "\"ZIP\",");
	fprintf(out, "\"COUNTRY\",");
	fprintf(out, "\"PHONE\",");
	fprintf(out, "\"WORKPHONE\",");
	fprintf(out, "\"FAX\",");
	fprintf(out, "\"MOBILEPHONE\",");
	fprintf(out, "\"NICK\",");
	fprintf(out, "\"URL\",");
	fprintf(out, "\"NOTES\",");
	fprintf(out, "\"ANNIVERSARY\"\n");

	init_csv_common(&ops);

	csv_export_common(out, e, allcsv_export_fields, NULL);

	return 0;
}

/*
 * Using filter helper
 */
#define FILTER_NAME allcsv
#define FILTER_DESCRIPTION N_("comma separated values (all fields)")
#define FILTER_IMPORT_FUNCTION allcsv_parse_file
#define FILTER_EXPORT_FUNCTION allcsv_export_database
#include "filter_helper.h"
