#ifndef _FILTERS_EXTERNAL_H
#define _FILTERS_EXTERNAL_H

enum {
	ACCESS_IN,
	ACCESS_OUT,
	ACCESS_BOTH
};

enum {
	CMD_ERRORS,
	CMD_STOP,
	CMD_PUTS,
	CMD_OPTIONS,
	CMD_ABOOK_OPTION,
	CMD_NEXT_LINE,
	CMD_PUT_FIELD,
	CMD_COMMIT_ITEM,
	CMD_NEXT_ITEM,
	CMD_GET_FIELD,
	CMD_FIELD_NAME,
	CMD_ENUMERATE,
	CMD_EMAILS,
};

enum {
	SEND_ERR_NONE,
	SEND_ERR_STDERR,
	SEND_ERR_FILTER
};

/* Everything above ERR_OK_SEPARATOR is an OK return code,
 * everything below is an actual error */
enum {
	ERR_OK = 0, /* must be first and equal to zero */
	ERR_OK_DECLARED_NEW_FIELD,
	ERR_OK_SEPARATOR, /* dummy entry for separating OK from errors */
	ERR_INVALID_VALUE,
	ERR_INVALID_OPTION,
	ERR_INVALID_CMD,
	ERR_CMD_NOT_AUTHORIZED,
	ERR_MALFORMED_REQUEST,
	ERR_UNDECLARED_FIELD,
	ERR_NO_NAME_FIELD,
};

#define send_error_string(err, str, i) \
	"%d >>> %s%s%s\n", err, str ? str : "", str ? ": " : "", errors[i]

#define send_data_fmt(...) do { \
	fprintf(out_data, __VA_ARGS__); \
	fflush(out_data); \
} while(0)

#define send_data(...) send_data_fmt("%s\n", __VA_ARGS__)

#endif /* _FILTERS_EXTERNAL_H */
