#ifndef _FILTERS_FILTER_H
#define _FILTERS_FILTER_H

/*
 * Heading part of the filter helper. Also see filter_helper.h.
 */


#define OPS_STRUCT	ops
#undef F_OP

#ifndef DEBUG
# define F_OP(x, ...)	OPS_STRUCT.x( __VA_ARGS__ )
#else
/* Detect illegal use of a function not passed to the filter through ops */
# include <assert.h>
# define F_OP(x, ...) \
	((void)assert(OPS_STRUCT.x != NULL), OPS_STRUCT.x( __VA_ARGS__ ))
#endif

static struct abook_ops OPS_STRUCT;


/* A bit of preprocessor magic to handle namespace */
#define SYM_LTX(filter, function) filter ## _filter_LTX_filter_ ## function
#define XSYM_LTX(filter, function) SYM_LTX(filter, function)

#ifndef N_
#define N_(str)	str
#endif

#endif /* _FILTERS_FILTER_H */
