
/*
 * $Id$
 *
 * (C) by abook developers
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_CONFIG_H
#	include "../config.h"
#endif
#include "../abook.h"
#include "../db_access.h"
#include "../misc.h"
#include "../xmalloc.h"

#include "filter_interface.h"
#include "filter.h"

#include "filter_misc.h" /* get_surname() */


static int
gcrd_export_database(FILE *out, struct db_enumerator e)
{
	int j;
	char *name;
	abook_list *emails, *em;

	db_enumerate_items(e) {
		fprintf(out, "BEGIN:VCARD\nFN:%s\n",
				safe_str(db_name_get(e.item)));

		name = get_surname(db_name_get(e.item));
	        for( j = strlen(db_name_get(e.item)) - 1; j >= 0; j-- ) {
	                if((db_name_get(e.item))[j] == ' ')
	                        break;
	        }
		fprintf(out, "N:%s;%.*s\n",
			safe_str(name),
			j,
			safe_str(db_name_get(e.item))
			);

		free(name);

		if(db_fget(e.item, ADDRESS))
			fprintf(out, "ADR:;;%s;%s;%s;%s;%s;%s\n",
				safe_str(db_fget(e.item, ADDRESS)),
				safe_str(db_fget(e.item, ADDRESS2)),
				safe_str(db_fget(e.item, CITY)),
				safe_str(db_fget(e.item, STATE)),
				safe_str(db_fget(e.item, ZIP)),
				safe_str(db_fget(e.item, COUNTRY))
				);

		if(db_fget(e.item, PHONE))
			fprintf(out, "TEL;HOME:%s\n", db_fget(e.item, PHONE));
		if(db_fget(e.item, WORKPHONE))
			fprintf(out, "TEL;WORK:%s\n",
					db_fget(e.item, WORKPHONE));
		if(db_fget(e.item, FAX))
			fprintf(out, "TEL;FAX:%s\n", db_fget(e.item, FAX));
		if(db_fget(e.item, MOBILEPHONE))
			fprintf(out, "TEL;CELL:%s\n",
					db_fget(e.item, MOBILEPHONE));

		if(*db_email_get(e.item)) {
			emails = csv_to_abook_list(db_email_get(e.item));

			for(em = emails; em; em = em->next)
				fprintf(out, "EMAIL;INTERNET:%s\n", em->data);

			abook_list_free(&emails);
		}

		if(db_fget(e.item, NOTES))
			fprintf(out, "NOTE:%s\n", db_fget(e.item, NOTES));
		if(db_fget(e.item, URL))
			fprintf(out, "URL:%s\n", db_fget(e.item, URL));

		fprintf(out, "END:VCARD\n\n");

	}

	return 0;
}


/*
 * Using filter helper
 */
#define FILTER_NAME gcrd
#define FILTER_DESCRIPTION N_("GnomeCard (VCard) addressbook")
#define FILTER_EXPORT_FUNCTION gcrd_export_database
#include "filter_helper.h"
