
/*
 * $Id$
 *
 * (C) by abook developers
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_CONFIG_H
#	include "../config.h"
#endif
#include "../abook.h"
#include "../db_access.h"
#include "../misc.h"
#include "../xmalloc.h"

#include "filter_interface.h"
#include "filter.h"


static int
spruce_export_database (FILE *out, struct db_enumerator e)
{
	char *email;

	fprintf(out, "# This is a generated file made by abook for the "
			"Spruce e-mail client.\n\n");

	db_enumerate_items(e) {
		if(strcmp(safe_str(db_email_get(e.item)), "")) {
			email = get_first_email(e.item);
			fprintf(out, "# Address %d\nName: %s\n"
					"Email: %s\nMemo: %s\n\n",
					e.item,
					db_name_get(e.item),
					email,
					safe_str(db_fget(e.item, NOTES))
					);
			xfree(email);
		}
	}

	fprintf (out, "# End of address book file.\n");

	return 0;
}

/*
 * Using filter helper
 */
#define FILTER_NAME spruce
#define FILTER_DESCRIPTION N_("Spruce address book")
#define FILTER_EXPORT_FUNCTION spruce_export_database
#include "filter_helper.h"
